<template>
    <article class="box" v-if="shippingMethodId">
        <h1 class="title is-5">Envio</h1> 
        <div class="columns" v-if="shippingMethods">
            <div class="column is-3" v-for="shipping in shippingMethods" :key="shipping.id">
                <div class="block" >
                    <b-radio v-model="shippingMethodId"
                        name="shippingMethodId"
                        :native-value="shipping.id"
                        @change.native="shippingMethodSelected(shipping)"
                        type="is-link"
                        >
                        {{ shipping.name }} - seu produto será entregue em até {{ shipping.delivery_time }} dias por 
                            R$ {{ shipping.price }}
                    </b-radio>
                </div>
            </div>  
        </div>
    </article>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'

export default {
    data(){
        return {
            selectedShippingMethod: null
        }
    },

    props: {
        shippingMethods: {
            required: true,
            type: Array
        }
    },

    created() {
        if (this.shippingMethods){
            this.switchShippingMethod(this.defaultShippingMethod)
        }
    },

    watch: {
        defaultShippingMethod(shippingMethod) {
            if (shippingMethod) {
                this.$emit('input', shippingMethod.id)
            }
        }
    },

    methods: {
        shippingMethodSelected(shipping){
            this.switchShippingMethod(shipping)
            this.updateShipping(shipping.id)
            localStorage.frete = shipping.price.replace('R$', '').trim();
            this.$emit('input', shipping.id)
            // this.setShipping(shipping)
            // this.$emit('changed', shipping.id)
        },
        switchShippingMethod(shippingMethod){
            this.selectedShippingMethod = shippingMethod
        },

        ...mapActions({
            setShipping: 'cart/setShipping',
            getCart: 'cart/getCart',
            updateShipping: 'cart/updateShipping'
        }),

        changed(shipping){
            localStorage.frete = shipping.price.replace('R$', '').trim();
            // this.setShipping(shipping)
            this.$emit('changed', shipping.id)
        }
    },

    computed: {
        ...mapGetters({
            shipping: 'cart/shipping',
        }),

        defaultShippingMethod() {
            return this.shippingMethods && this.shippingMethods.find(s => s.default === true)
        },

        shippingMethodId: {
            get(){
                return this.shipping ? this.shipping.id : ''
            },
            set(shippingMethodId){
                this.setShipping(this.defaultShippingMethod)
            }
        }
    }
    
}
</script>

<style scoped>
    .column {
        margin-top: 10px
    }

    .block {
        border: 1.5px solid #CCC;
        padding: 10px;
        font-size: .8em;
        /* background-color: rgb(240, 240, 240); */
    }

    .block:hover {
        border: 2px solid #8c67ef;
        /* background-image: linear-gradient(180deg, rgb(240, 240, 240), rgb(255, 255, 255)); */
    }
</style>